import { IS_PRODUCTION } from './environment.js';

function initDevTools() {
  if (IS_PRODUCTION || typeof window === 'undefined') return;
  var w = window;
  var services = new Set();
  var serviceListeners = new Set();
  w.__xstate__ = w.__xstate__ || {
    services: services,
    register: function (service) {
      services.add(service);
      serviceListeners.forEach(function (listener) {
        return listener(services);
      });
    },
    onRegister: function (listener) {
      serviceListeners.add(listener);
      listener(services);
    }
  };
  return w.__xstate__;
}

if (!IS_PRODUCTION) {
  initDevTools();
}

function registerService(service) {
  if (IS_PRODUCTION || typeof window === 'undefined') return;
  var dev = initDevTools();
  dev && dev.register(service);
}

export { registerService };