"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var environment_1 = require("./environment");
function initDevTools() {
    if (environment_1.IS_PRODUCTION || typeof window === 'undefined')
        return;
    var w = window;
    var services = new Set();
    var serviceListeners = new Set();
    w.__xstate__ = w.__xstate__ || {
        services: services,
        register: function (service) {
            services.add(service);
            serviceListeners.forEach(function (listener) { return listener(services); });
        },
        onRegister: function (listener) {
            serviceListeners.add(listener);
            listener(services);
        }
    };
    return w.__xstate__;
}
if (!environment_1.IS_PRODUCTION) {
    initDevTools();
}
function registerService(service) {
    if (environment_1.IS_PRODUCTION || typeof window === 'undefined')
        return;
    var dev = initDevTools();
    dev && dev.register(service);
}
exports.registerService = registerService;
